/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 352 (Exercise B.2.2)
**
*/

new;
library rpb,pgraph;

cls;

print;
print "=====================  Question 1.a  =======================================";

alpha = 0.35;
x = seqa(0,1/250,251);
y = x;
p = zeros(rows(x),1);
p[1] = 1.0;
y = x~x^alpha~cumsumc(p);

x0 = 20;
y0 = 100 * (0.20^0.35);

pqgwin many;

graphset;
  begwind;
  makewind(9,6.855,0,0,1);
  makewind(9,6.855,0,0,1);

  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3|6|1; _plwidth = 10; _pcolor = 0|1|0;
  ytics(0,100,20,2);
  xtics(0,100,20,2);
  xlabel("\216x (in %)");
  ylabel("\216y (in %)");

  setwind(1);

    e = ones(rows(x),1);
    _pline = e.*(1~6)~100*x~100*x~100*x~100*y[.,2]~e.*(1~2~5);
    _pline = _pline | 1~3~0.01~0~0.01~100~1~0~10;
    _plegstr = "No concentration\000Lorenz curve\000Perfect concentration";
    _plegctl = {2 5 5 2};
    xy(-100*x,-100*y);

  setwind(2);
    _plegctl = 0;
    _pline = 1~6~x0~0~x0~y0~1~4~10 |
             1~6~0~100*(0.20^(0.35))~20~100*(0.20^(0.35))~1~4~10 ;
    _pmsgstr = "A\000B\00020%\00056.9%";
    _pmsgctl = 40~55~0.25~0~1~0~10|
             25~85~0.25~0~1~0~10 |
             21~10~0.12~-90~1~4~7 |
             6~58~0.12~0~1~4~7 ;
    _psym = x0~y0~8~2.5~4~1~10 ;
    xy(100*x,100*y);

    graphprt("-c=1 -cf=app2-2-2-1.eps");

  endwind;

print;
print "=====================  Question 1.b  =======================================";

alpha = 0.10;
y1 = x^alpha;
  
alpha = 0.50;
y2 = x^alpha;

alpha = 0.90;
y3 = x^alpha;

graphset;
  _pdate = ""; _pnum = 2; _pframe = 0;
  _pltype = 6|1|3; _plwidth = 10; _pcolor = 1|2|3;  
  fonts("simplex simgrma");
  ytics(0,100,20,2);
  xtics(0,100,20,2);
  xlabel("\216x (in %)");
  ylabel("\216y (in %)");
  _plegstr = "\202a\201 = 10%\000\202a\201 = 50%\000\202a\201 = 90%";
  _plegctl = {2 5 6 2};
  graphprt("-c=1 -cf=app2-2-2-2.eps");
  xy(100*x,100*(y1~y2~y3));

print;
print "=====================  Question 3.a  =======================================";

let w[3,5] = 0.00 0.10 0.20 0.30 0.40
             0.40 0.20 0.00 0.30 0.10
             0.20 0.15 0.25 0.35 0.05;
w = w';

let sigma = 0.02 0.05 0.10 0.20 0.30;
rho = eye(5);
Cov = rho .* sigma .* sigma';
Bounds = (0~1) .* ones(5,1);
{w_min,sigma_min,retcode} = Compute_MV_Portfolio(cov,ones(1,5),1,0,0,Bounds);
w = w~w_min;
w = w~ones(5,1)/5~zeros(5,1);
w[1,cols(w)] = 1.0;

print ftosa(100*w,"%lf",3,3);

print;
print "=====================  Question 3.b  =======================================";

{H,H_star,N} = Herfindahl_Index(w);
G = Compute_Discrete_Gini(w);

print ftosa(H~G~N,"%lf",3,2);

proc (1) = Compute_Discrete_Gini(y);
  local n,i,G;

  n = cols(y);
  G = zeros(n,1);
  i = 1; 
  do until i > n;
    G[i] = _Compute_Discrete_Gini(packr(y[.,i]));
    i = i + 1;
  endo;

  retp(G);
endp;

proc (1) = _Compute_Discrete_Gini(y);
  local n,x,dx,w,I,G;

  n = rows(y);
  y = rev(sortc(y,1));
  y = cumsumc(y);
  y = y/maxc(y);
  x = seqa(1,1,n)/n;
  y = 0 | y;
  x = 0 | x;
  dx = 1/n;
  
  w = ones(n + 1,1);
  w[1] = 0.5;
  w[n+1] = 0.5;
  I = dx*sumc(y .* w);
  G = 2*I - 1.0;

  retp(G);
endp;