/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 355 (Exercise B.2.5)
**
*/

new;
library rpb,pgraph;

cls;

__output = 0;

/*
**> Question 1
**
*/

let sigma = 0.20 0.20 0.15 0.15 0.10 0.10;

let rho =   1.0
            0.7  1.0
            0.8  0.5  1.0
           -0.3 -0.2 -0.3  1.0
           -0.2 -0.1 -0.1  0.2 1.0
           -0.4 -0.1 -0.1  0.2 0.0 1.0;

rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';
n = rows(cov);

let b = 0.40 0.30 0.30 0.00 0.00 0.00;

nSolutions = 2^3;

all_result1 = miss(zeros(nSolutions*4,n+1),0);

print;
print "=====================  Question 1.a  =======================================";

i = 1;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov,b);
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_result1[1+(i-1)*4:i*4,1:n] = 100*(x~mr~rc~prc)';
all_result1[1+(i-1)*4,n+1] = 100*vol;

print ftosa(all_result1[1:4,.],"%lf",3,2);

print;
print "=====================  Question 1.b  =======================================";

i = 2;
let indx = 1 2 3;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov[indx,indx],b[indx]);
tmp = zeros(n,1);
tmp[indx] = x;
x = tmp;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_result1[1+(i-1)*4:i*4,1:n] = 100*(x~mr~rc~prc)';
all_result1[1+(i-1)*4,n+1] = 100*vol;

print ftosa(all_result1[5:8,.],"%lf",3,2);

print;
print "=====================  Question 1.c  =======================================";

i = 3;
let indx = 1 2 3 4;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov[indx,indx],b[indx]);
tmp = zeros(n,1);
tmp[indx] = x;
x = tmp;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_result1[1+(i-1)*4:i*4,1:n] = 100*(x~mr~rc~prc)';
all_result1[1+(i-1)*4,n+1] = 100*vol;

i = 4;
let indx = 1 2 3 5;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov[indx,indx],b[indx]);
tmp = zeros(n,1);
tmp[indx] = x;
x = tmp;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_result1[1+(i-1)*4:i*4,1:n] = 100*(x~mr~rc~prc)';
all_result1[1+(i-1)*4,n+1] = 100*vol;

i = 5;
let indx = 1 2 3 6;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov[indx,indx],b[indx]);
tmp = zeros(n,1);
tmp[indx] = x;
x = tmp;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_result1[1+(i-1)*4:i*4,1:n] = 100*(x~mr~rc~prc)';
all_result1[1+(i-1)*4,n+1] = 100*vol;

i = 6;
let indx = 1 2 3 4 5;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov[indx,indx],b[indx]);
tmp = zeros(n,1);
tmp[indx] = x;
x = tmp;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_result1[1+(i-1)*4:i*4,1:n] = 100*(x~mr~rc~prc)';
all_result1[1+(i-1)*4,n+1] = 100*vol;

i = 7;
let indx = 1 2 3 4 6;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov[indx,indx],b[indx]);
tmp = zeros(n,1);
tmp[indx] = x;
x = tmp;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_result1[1+(i-1)*4:i*4,1:n] = 100*(x~mr~rc~prc)';
all_result1[1+(i-1)*4,n+1] = 100*vol;

i = 8;
let indx = 1 2 3 5 6;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov[indx,indx],b[indx]);
tmp = zeros(n,1);
tmp[indx] = x;
x = tmp;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_result1[1+(i-1)*4:i*4,1:n] = 100*(x~mr~rc~prc)';
all_result1[1+(i-1)*4,n+1] = 100*vol;

print ftosa(all_result1[9:nSolutions*4,.],"%lf",3,2);

/*
**> Question 2
**
*/

let rho =   1.0
            0.7   1.0
            0.8   0.5   1.0
            0.3   0.2   0.3   1.0
           -0.2  -0.1  -0.1  -0.2 1.0
            0.4   0.1   0.1   0.2 0.0 1.0;

rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';
n = rows(cov);

nSolutions = 2;
all_result2 = miss(zeros(nSolutions*4,n+1),0);

print;
print "=====================  Question 2.a  =======================================";

i = 1;
let indx = 1 2 3;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov[indx,indx],b[indx]);
tmp = zeros(n,1);
tmp[indx] = x;
x = tmp;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_result2[1+(i-1)*4:i*4,1:n] = 100*(x~mr~rc~prc)';
all_result2[1+(i-1)*4,n+1] = 100*vol;

print ftosa(all_result2[1:4,.],"%lf",3,2);

print;
print "=====================  Question 2.b  =======================================";

i = 2;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov,b);
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_result2[1+(i-1)*4:i*4,1:n] = 100*(x~mr~rc~prc)';
all_result2[1+(i-1)*4,n+1] = 100*vol;

print ftosa(all_result2[5:8,.],"%lf",3,2);

print;
print "=====================  Question 3  =======================================";

let rho =   1.0
            0.7   1.0
            0.8   0.5   1.0
            0.3   0.2   0.3   1.0
            0.2   0.1   0.1   0.2 1.0
            0.4   0.1   0.1   0.2 0.0 1.0;

rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';
n = rows(cov);

nSolutions = 1;
all_result3 = miss(zeros(nSolutions*4,n+1),0);

i = 1;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov,b);
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_result3[1+(i-1)*4:i*4,1:n] = 100*(x~mr~rc~prc)';
all_result3[1+(i-1)*4,n+1] = 100*vol;

print ftosa(all_result3,"%lf",3,2);

print;
print "=====================  Question 4  =======================================";

let sigma = 0.20 0.20 0.15 0.02 0.02 0.02;

let rho =   1.0
            0.7  1.0
            0.8  0.5  1.0
           -0.3 -0.2 -0.3  1.0
           -0.2 -0.1 -0.1  0.2 1.0
           -0.4 -0.1 -0.1  0.2 0.0 1.0;

rho = xpnd(rho);
call invpd(rho);

cov = rho .* sigma .* sigma';
n = rows(cov);

nSolutions = 2;
all_result4 = miss(zeros(nSolutions*4,n+1),0);

i = 1;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov,b);
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_result4[1+(i-1)*4:i*4,1:n] = 100*(x~mr~rc~prc)';
all_result4[1+(i-1)*4,n+1] = 100*vol;

print ftosa(all_result4[1:4,.],"%lf",3,2);

i = 2;
let indx = 1 2 3;
{x,vol,mr,rc,prc} = Compute_RB_Portfolio(0,cov[indx,indx],b[indx]);
tmp = zeros(n,1);
tmp[indx] = x;
x = tmp;
{vol,mr,rc,prc} = Compute_Risk_Contribution(x,cov);
all_result4[1+(i-1)*4:i*4,1:n] = 100*(x~mr~rc~prc)';
all_result4[1+(i-1)*4,n+1] = 100*vol;

print ftosa(all_result4[5:8,.],"%lf",3,2);

