/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 28 (Correlation matrix 1.16)
**
*/

new;
library rpb;

cls;

PathName = "data\\";
datFileName = PathName $+ "equity-indices-weekly.dat";
Data = loadd(datFileName);
vnames = lower("" $+ getname(datFileName));

BeginDate = 20050101;
LastDate = 20111231;
Data = selif(Data,(Data[.,1] .>= BeginDate) .and (Data[.,1] .<= LastDate));

let string selected_names = "spx" "sxxe" "ukx" "tpx" "bovespa" "rts" "nifty" "hsi";
indx = indsav(selected_names,vnames);
Dates = Data[.,1];
x = Data[.,indx];
R = x ./ lag1(x) - 1.0;
R = packr(R);

C = corrx(R);
sigma = sqrt(52) * stdc(R);
print ftosa(miss(lowmat(C),0),"%lf",3,2);
print ftosa(100*sigma,"%lf",3,1);
