/*
** Thierry Roncalli
** Introduction to Risk Parity & Budgeting
**
**> Page 116 (Tables 2.14 and 2.15)
**
*/

new;
library rpb,pgraph;

cls;

let sigma = 0.10 0.20 0.30 0.40;
let rho =   1.00
            0.80   1.00
            0.20   0.20  1.00
            0.20   0.20  0.50  1.00;
rho = xpnd(rho);
cov = rho .* sigma .* sigma';
call invpd(cov);
n = rows(sigma);

SR = 0.50;

let b = 0.20 0.25 0.40 0.15;
{x,risk,mr,rc,prc} = Compute_RB_Portfolio(0,cov,b);
phi = SR/risk;
mu = phi .* (cov*x);
pc = x .* mu;
perf = sumc(pc);
ppc = pc/sumc(pc);

result1 = 100*(x~mr~mu~pc~ppc) |
          100*(error(0)~error(0)~error(0)~perf~error(0));
risk1 = risk;
phi1 = phi;

x1_rb = x;
{x1_mv,mu1,sigma1,gamma1,retcode1} = Compute_MVO_Portfolio(mu,cov,ones(1,n),1,0,0,0,risk,2); 

let b = 0.10 0.10 0.10 0.70;
{x,risk,mr,rc,prc} = Compute_RB_Portfolio(0,cov,b);
phi = SR/risk;
mu = phi .* (cov*x);
pc = x .* mu;
perf = sumc(pc);
ppc = pc/sumc(pc);

result2 = 100*(x~mr~mu~pc~ppc) |
          100*(error(0)~error(0)~error(0)~perf~error(0));
risk2 = risk;
phi2 = phi;

x2_rb = x;
{x2_mv,mu2,sigma2,gamma2,retcode2} = Compute_MVO_Portfolio(mu,cov,ones(1,n),1,0,0,0,risk,2); 

cls;

print ftosa(result1,"%lf",3,2);
print "-----------------------------------------------------------------";
print ftosa(result2,"%lf",3,2);
print "-----------------------------------------------------------------";
print ftosa(100*(risk1~risk2),"%lf",3,2);
print ftosa(phi1~phi2,"%lf",3,2);
print "-----------------------------------------------------------------";
print ftosa(100*(x1_rb~x1_mv),"%lf",3,3);
print "-----------------------------------------------------------------";
print ftosa(100*(x2_rb~x2_mv),"%lf",3,3);


